#Compile Exe                        'Uses ScrollWindow() in conjunction with SetScrollInfo().
#Dim All                            'Don't even think about not using this!
#Include "Win32api.inc"             'You ought to spend some considerable time examining this file with Notepad.
Global strLine() As String          'Dynamic strings are nice.  Unfortunately, you need to be a C or assembler
%LAST_LINE  =    100                'programmer to really appreciate them!
%DEBUG      =    %FALSE
#If %DEBUG                          'If you set %DEBUG to %TRUE, an output log file will be created and
    Global fp    As Long            'produce reams of output!
#EndIf


Type WndEventArgs                   'Package frequently needed parameters
  hIns As Dword                     'Several of these variables need to be statics so as to retain Scroll
  hWnd As Dword                     'information between WndProc() Calls.
  wParam As Dword
  lParam As Dword
  cyChar As Dword                   'Verticle Size of a Character
  iBegin As Long                    'Offset into array of first line (array holds lines of text to scroll)
  iScrollRange As Long              'iBegin to iEnd, as long as these values are in iScrollRange
  iLinesVisible As Long             'One based count of lines visible on screen, adjusted as user resizes screen.
  lpsi As SCROLLINFO                'Type / structure Microsoft now wishes us to use to set scroll position and
End Type                            'scroll range


Function fnWndProc_OnCreate(wea As WndEventArgs) As Long
  Local ps As PAINTSTRUCT           'Examine this in Win32Api.inc!!
  Local tm As TEXTMETRIC            'Likewise with this!
  Register i As Dword
  Local hDC As Dword

  #If %DEBUG
      fp=Freefile
      Open "Output.txt" For Output As #fp
      Print #fp, "Entering fnWndProc_OnCreate()"
  #EndIf
  ReDim strLine(%LAST_LINE)         'Allocate memory buffer for lines of text to scroll
  For i = 0 To UBound(strLine,1)    'Fill buffers with lines of text
    strLine(i)=Str$(i)+"  "+ _
    "PowerBASIC Scrolling Demo!"
  Next i
  hDC=GetDC(wea.hWnd)               'In Windows, you need something called a 'Device Context' to get
  Call GetTextMetrics(hDC,tm)       'info on how things such as text will be displayed.  To find out
  wea.cyChar=tm.tmHeight            'how many lines of text will be visible on any screen size chosen
  Call ReleaseDC(wea.hWnd,hDC)      'by a user, we need the height of a character, 'wea.cyChar'.
  wea.lpsi.cbSize=SizeOf(wea.lpsi)  'Api Help wants us to specify size of SCROLLINFO structure.
  #If %DEBUG
      Print #fp, "wea.iBegin        = "wea.iBegin
      Print #fp, "wea.iScrollRange  = "wea.iScrollRange
      Print #fp, "wea.iLinesVisible = "wea.iLinesVisible
      Print #fp, "Leaving fnWndProc_OnCreate()"
      Print #fp,
  #EndIf

  fnWndProc_OnCreate=0
End Function


Function fnWndProc_OnSize(wea As WndEventArgs) As Long
  #If %DEBUG
      Print #fp, "Entering fnWndProc_OnSize()"
  #EndIf
  wea.iLinesVisible=Fix(HiWrd(wea.lParam)/wea.cyChar)      'wea.lParam holds height of client area in pixels
  wea.iScrollRange=%LAST_LINE-wea.iLinesVisible+1          'Last Line is #100, but that's a zero based count,
  wea.lpsi.fMask=%SIF_ALL                                  'so add one to it (iLinesVisible is one based).
  wea.lpsi.nMin=0 : wea.lpsi.nMax=wea.iScrollRange         'Set mins and maxes in lpsi (SCROLLINFO type)
  wea.lpsi.nPos=wea.iBegin                                 'iBegin is zero based number of first line visible
  Call SetScrollInfo(wea.hWnd,%SB_VERT,wea.lpsi,%TRUE)     'in window.
  #If %DEBUG
      Print #fp, "wea.iBegin        = "wea.iBegin
      Print #fp, "wea.iScrollRange  = "wea.iScrollRange
      Print #fp, "wea.iLinesVisible = "wea.iLinesVisible
      Print #fp, "Leaving fnWndProc_OnSize()"
      Print #fp,
  #EndIf

  fnWndProc_OnSize=0
End Function


Function fnWndProc_OnKeyDown(wea As WndEventArgs) As Long  'We already have code in place to handle scroll
  Select Case wea.wParam                                   'line up, scroll line down, scroll page up, etc.
    Case %VK_PGUP                                          'That being the case, there's no sense in
      Call SendMessage(wea.hWnd,%WM_VSCROLL,%SB_PAGEUP,0)  'duplicating that code here.  Since proper
    Case %VK_UP                                            'message processing logic exists for these scroll
      Call SendMessage(wea.hWnd,%WM_VSCROLL,%SB_LINEUP,0)  'messages, when keyboard messages are received
    Case %VK_PGDN                                          'in here, we'll just send the corresponding
      Call SendMessage(wea.hWnd,%WM_VSCROLL,%SB_PAGEDOWN,0)'scroll message to the Window Procedure directly.
    Case %VK_DOWN
      Call SendMessage(wea.hWnd,%WM_VSCROLL,%SB_LINEDOWN,0)
  End Select

  fnWndProc_OnKeyDown=0
End Function


Function fnWndProc_OnVScroll(wea As WndEventArgs) As Long
  #If %DEBUG
      Print #fp, "Entering fnWndProc_OnVScroll()"
  #EndIf
  Select Case LoWrd(wea.wParam)
    Case %SB_LINEUP
      If wea.iBegin Then                                                 'Check to make sure not already at
         Decr wea.iBegin                                                 'strLine(0)
         Call ScrollWindow(wea.hWnd,0,wea.cyChar,ByVal 0,ByVal 0)        'Bump everything 16 pixels (cyChar) down.
         wea.lpsi.fMask=%SIF_POS
         wea.lpsi.nPos=wea.iBegin
         Call SetScrollInfo(wea.hWnd,%SB_VERT,wea.lpsi,%TRUE)
      End If
      #If %DEBUG
          Print #fp, "Lowrd(wea.wParam) =SB_LINEUP"
      #EndIf
    Case %SB_PAGEUP
      If wea.iBegin-wea.iLinesVisible >= 0 Then
         wea.iBegin = wea.iBegin - wea.iLinesVisible
         Call ScrollWindow(wea.hWnd,0,wea.iLinesVisible*wea.cyChar,ByVal 0,ByVal 0)
         wea.lpsi.fMask=%SIF_POS       'The fMask member of lpsi prepares for the SetScrollInfo
         wea.lpsi.nPos=wea.iBegin      'call and tells the function which members we are setting
         Call SetScrollInfo(wea.hWnd,%SB_VERT,wea.lpsi,%TRUE)
      Else
         Call ScrollWindow(wea.hWnd,0,wea.iBegin*wea.cyChar,ByVal 0,ByVal 0)
         wea.iBegin=0
         wea.lpsi.fMask=%SIF_POS
         wea.lpsi.nPos=wea.iBegin
         Call SetScrollInfo(wea.hWnd,%SB_VERT,wea.lpsi,%TRUE)
      End If
      #If %DEBUG
          Print #fp, "Lowrd(wea.wParam) =SB_PAGEDOWN"
      #EndIf
    Case %SB_LINEDOWN
      If wea.iBegin+wea.iLinesVisible<=%LAST_LINE Then
         Incr wea.iBegin
         Call ScrollWindow(wea.hWnd,0,-wea.cyChar,ByVal 0,ByVal 0)
         wea.lpsi.fMask=%SIF_POS
         wea.lpsi.nPos=wea.iBegin
         Call SetScrollInfo(wea.hWnd,%SB_VERT,wea.lpsi,%TRUE)
      End If
      #If %DEBUG
          Print #fp, "Lowrd(wea.wParam) =SB_LINEDOWN"
      #EndIf
    Case %SB_PAGEDOWN
      If wea.iBegin+wea.iLinesVisible<=%LAST_LINE Then
         wea.iBegin = wea.iBegin + wea.iLinesVisible
         Call ScrollWindow(wea.hWnd,0,-wea.iLinesVisible*wea.cyChar,ByVal 0,ByVal 0)
         wea.lpsi.fMask=%SIF_POS
         wea.lpsi.nPos=wea.iBegin
         Call SetScrollInfo(wea.hWnd,%SB_VERT,wea.lpsi,%TRUE)
      End If
      #If %DEBUG
          Print #fp, "Lowrd(wea.wParam) =SB_PAGEDOWN"
      #EndIf
    Case %SB_THUMBTRACK
      wea.lpsi.fMask=%SIF_TRACKPOS
      Call GetScrollInfo(wea.hWnd,%SB_VERT,wea.lpsi)
      wea.iBegin=wea.lpsi.nTrackPos
      Call InvalidateRect(wea.hWnd,ByVal 0,%TRUE)
      wea.lpsi.fMask=%SIF_POS
      wea.lpsi.nPos=wea.lpsi.nTrackPos
      Call SetScrollInfo(wea.hWnd,%SB_VERT,wea.lpsi,%TRUE)
      #If %DEBUG
          Print #fp, "Lowrd(wea.wParam) =SB_THUMBTRACK"
      #EndIf
  End Select
  #If %DEBUG
      Print #fp, "wea.iBegin        = "wea.iBegin
      Print #fp, "wea.iScrollRange  = "wea.iScrollRange
      Print #fp, "wea.iLinesVisible = "wea.iLinesVisible
      Print #fp, "Leaving fnWndProc_OnVScroll()"
      Print #fp,
  #EndIf

  fnWndProc_OnVScroll=0
End Function


Function fnWndProc_OnPaint(wea As WndEventArgs) As Long
  Local iStart As Long, iFinish As Long,iLine As Long
  Local ps As PAINTSTRUCT
  Register i As Dword
  Local hDC As Dword

  #If %DEBUG
      Print #fp, "Entering fnWndProc_OnPaint()"
  #EndIf
  hDC=BeginPaint(wea.hWnd,ps)
  #If %DEBUG
      Print #fp, "wea.iBegin        = "wea.iBegin
      Print #fp, "wea.iScrollRange  = "wea.iScrollRange
      Print #fp, "wea.iLinesVisible = "wea.iLinesVisible
  #EndIf
  iStart=ps.rcPaint.nTop\wea.cyChar
  iFinish=Ceil(ps.rcPaint.nBottom/wea.cyChar)-1
  #If %DEBUG
      Print #fp, "iStart            = "iStart
      Print #fp, "iFinish           = "iFinish
      Print #fp,
      Print #fp, "i              i*wea.cyChar  iLine         strLine(iLine)"
      Print #fp, "======================================================================"
  #EndIf
  For i=iStart To iFinish
    iLine=wea.iBegin+i
    If iLine<=%LAST_LINE Then
       #If %DEBUG
           Print #fp, i,i*wea.cyChar,iLine,strLine(iLine)
       #EndIf
       Call TextOut(hDC,0,i*wea.cyChar,ByVal StrPtr(strLine(iLine)),Len(strLine(iLine)))
    End If
  Next i
  Call EndPaint(wea.hWnd,ps)
  #If %DEBUG
      Print #fp,
      Print #fp, "Leaving fnWndProc_OnPaint()"
      Print #fp, : Print #fp, : Print #fp,
  #EndIf

  fnWndProc_OnPaint=0
End Function


Function fnWndProc_OnClose(wea As WndEventArgs) As Long
  #If %DEBUG
      Close #fp
  #EndIf
  Erase strLine
  Call PostQuitMessage(0)

  fnWndProc_OnClose=0
End Function


Function fnWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Static wea As WndEventArgs

  Select Case wMsg
    Case %WM_CREATE
      wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
      fnWndProc=fnWndProc_OnCreate(wea)
      Exit Function
    Case %WM_SIZE
      wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
      fnWndProc=fnWndProc_OnSize(wea)
      Exit Function
    Case %WM_KEYDOWN
      wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
      fnWndProc=fnWndProc_OnKeyDown(wea)
      Exit Function
    Case %WM_VSCROLL
      wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
      fnWndProc=fnWndProc_OnVScroll(wea)
      Exit Function
    Case %WM_PAINT
      wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
      fnWndProc=fnWndProc_OnPaint(wea)
      Exit Function
    Case %WM_CLOSE
      wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
      fnWndProc=fnWndProc_OnClose(wea)
      Exit Function
  End Select

  fnWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function


Function WinMain(ByVal hIns As Long, ByVal hPrev As Long, ByVal lpCmdLn As Asciiz Ptr, ByVal iShow As Long) As Long
  Local hMainWnd As Dword,dwStyle As Dword
  Local winclass As WndClassEx
  Local szAppName As Asciiz*16
  Local Msg As tagMsg

  szAppName="Scroll Window"
  winclass.cbSize=SizeOf(winclass)                       :winclass.style=%CS_HREDRAW Or %CS_VREDRAW
  winclass.lpfnWndProc=CodePtr(fnWndProc)                :winclass.cbClsExtra=0
  winclass.cbWndExtra=0                                  :winclass.hInstance=hIns
  winclass.hIcon=LoadIcon(%NULL,ByVal %IDI_APPLICATION)  :winclass.hCursor=LoadCursor(%NULL,ByVal %IDC_ARROW)
  winclass.hbrBackground=GetStockObject(%WHITE_BRUSH)    :winclass.lpszMenuName=%NULL
  winclass.lpszClassName=VarPtr(szAppName)               :winclass.hIconSm=0
  Call RegisterClassEx(winclass)
  dwStyle=%WS_THICKFRAME Or %WS_MINIMIZEBOX Or %WS_VISIBLE Or %WS_VSCROLL Or %WS_SYSMENU
  hMainWnd=CreateWindowEx(0,szAppName,szAppName,dwStyle,200,100,300,228,%HWND_DESKTOP,0,hIns,ByVal 0)
  Call ShowWindow(hMainWnd,iShow)
  Call UpdateWindow(hMainWnd)
  While GetMessage(Msg,%NULL,0,0)
    Call TranslateMessage(Msg)
    Call DispatchMessage(Msg)
  Wend

  Function=msg.wParam
End Function
