#Compile Exe                           'Uses ScrollWindow() in conjunction with SetScrollInfo().
#Dim All                               'Don't even think about not using this!
#Include "Win32api.inc"                'You ought to spend some considerable time examining this file with Notepad.
Global strLine() As String             'Dynamic strings are nice.  Unfortunately, you need to be a C programmer to
%LAST_LINE=25                          'really appreciate them!
Global fp As Long

Type WndEventArgs                      'Package frequently needed parameters
  hIns As Dword
  hWnd As Dword
  wParam As Dword
  lParam As Dword
  cyChar As Dword                      'Verticle Size of a Character
  iBegin As Long                       'Offset into array of first line (array holds lines of text to scroll)
  iScrollRange As Long                 'iBegin to iEnd, as long as these values are in iScrollRange
  iLinesVisible As Long                'One based count of lines visible on screen, adjusted as user resizes screen.
  lpsi As SCROLLINFO                   'Type / structure Microsoft now wishes us to use to set scroll position and
End Type                               'scroll range


Function fnWndProc_OnCreate(wea As WndEventArgs) As Long
  Local ps As PAINTSTRUCT
  Local tm As TEXTMETRIC
  Register i As Dword
  Local hDC As Dword
  Local rc As RECT

  fp=Freefile
  Open "Output.txt" For Output As #fp
  Print #fp, "Entering fnWndProc_OnCreate()"
  ReDim strLine(%LAST_LINE)            'Allocate memory buffer for lines of text to scroll
  For i = 0 To UBound(strLine,1)       'Fill buffers with lines of text
    strLine(i)=Str$(i)+"  "+ _
    "PowerBASIC Scrolling Demo!"
  Next i
  hDC=GetDC(wea.hWnd)                  'In Windows, you need something called a 'Device Context' to get
  Call GetTextMetrics(hDC,tm)          'info on how things such as text will be displayed.  To find out
  wea.cyChar=tm.tmHeight               'how many lines of text will be visible on any screen size chosen
  Call ReleaseDC(wea.hWnd,hDC)         'by a user, we need the height of a character, 'wea.cyChar'.
  wea.lpsi.cbSize=SizeOf(wea.lpsi)     'Api Help wants us to specify size of SCROLLINFO structure.
  Call GetClientRect(wea.hWnd,rc)
  wea.iBegin=0
  wea.iLinesVisible=Fix(rc.nBottom/wea.cyChar)            '200 / 16 = 12.5 but 200 \ 16 = 12
  Print #fp,"wea.iLinesVisible="wea.iLinesVisible
  wea.iScrollRange=%LAST_LINE-wea.iLinesVisible+1         '25 - 12 + 1 = 14
  Print #fp, "wea.iScrollRange="wea.iScrollRange
  wea.lpsi.fMask=%SIF_ALL
  wea.lpsi.nMin=0 : wea.lpsi.nMax=wea.iScrollRange
  wea.lpsi.nPos=wea.iBegin
  Call SetScrollInfo(wea.hWnd,%SB_VERT,wea.lpsi,%TRUE)
  Print #fp, "wea.cyChar = "wea.cyChar
  Print #fp, "Leaving fnWndProc_OnCreate()"
  Print #fp, : Print #fp,
  '
  fnWndProc_OnCreate=0
End Function


Function fnWndProc_OnVScroll(wea As WndEventArgs) As Long
  Select Case LoWrd(wea.wParam)
    Case %SB_LINEUP
      If wea.iBegin Then
         Decr wea.iBegin
         Call ScrollWindow(wea.hWnd,0,wea.cyChar,ByVal 0,ByVal 0)
         wea.lpsi.fMask=%SIF_POS
         wea.lpsi.nPos=wea.iBegin
         Call SetScrollInfo(wea.hWnd,%SB_VERT,wea.lpsi,%TRUE)
      End If
    Case %SB_LINEDOWN
      If wea.iBegin+wea.iLinesVisible<=%LAST_LINE Then
         Incr wea.iBegin
         Call ScrollWindow(wea.hWnd,0,-wea.cyChar,ByVal 0,ByVal 0)
         wea.lpsi.fMask=%SIF_POS
         wea.lpsi.nPos=wea.iBegin
         Call SetScrollInfo(wea.hWnd,%SB_VERT,wea.lpsi,%TRUE)
      End If
  End Select
  '
  fnWndProc_OnVScroll=0
End Function


Function fnWndProc_OnPaint(wea As WndEventArgs) As Long
  Local iStart As Long, iFinish As Long,iLine As Long
  Static iPainted As Long                        '<<<    'This is the variable
  Local ps As PAINTSTRUCT                                'I used to sabotage
  Register i As Dword                                    'this program.  After
  Local hDC As Dword                                     'three paint messages
                                                         'the program won't
  Print #fp, "Entering fnWndProc_OnPaint()"              'paint the area
  hDC=BeginPaint(wea.hWnd,ps)                            'uncovered by the
  Print #fp, "wea.iBegin          = "wea.iBegin          'ScrollWindow() call
  Print #fp, "wea.iScrollRange    = "wea.iScrollRange    'anymore, and the text
  Print #fp, "wea.iLinesVisible   = "wea.iLinesVisible   'will gradually scroll
  If iPainted<3 Then                                     'off the screen!  Not
     iStart=ps.rcPaint.nTop\wea.cyChar                   'good!
     iFinish=Ceil(ps.rcPaint.nBottom/wea.cyChar)-1
     Print #fp, "ps.rcPaint.nTop     = "ps.rcPaint.nTop        'We only get
     Print #fp, "ps.rcPaint.nBottom  = "ps.rcPaint.nBottom     'inside this if
     Print #fp, "iStart              = "iStart                 'statement for
     Print #fp, "iFinish             = "iFinish                'the 1st three
     Print #fp,                                                'WM_PAINTs
     Print #fp, "i              i*wea.cyChar  iLine         strLine(iLine)"
      Print #fp, "======================================================================"
     For i=iStart To iFinish
       iLine=wea.iBegin+i
       If iLine<=%LAST_LINE Then
          Print #fp, i,i*wea.cyChar,iLine,strLine(iLine)
          Call TextOut(hDC,0,i*wea.cyChar,ByVal StrPtr(strLine(iLine)),Len(strLine(iLine)))
       End If
     Next i
     Incr iPainted
  End If
  Call EndPaint(wea.hWnd,ps)
  Print #fp,
  Print #fp, "Leaving fnWndProc_OnPaint()"
  Print #fp, : Print #fp, : Print #fp,

  fnWndProc_OnPaint=0
End Function


Function fnWndProc_OnClose(wea As WndEventArgs) As Long
  Close #fp
  Erase strLine
  Call PostQuitMessage(0)

  fnWndProc_OnClose=0
End Function


Function fnWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Static wea As WndEventArgs

  Select Case wMsg
    Case %WM_CREATE
      wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
      fnWndProc=fnWndProc_OnCreate(wea)
      Exit Function
    Case %WM_VSCROLL
      wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
      fnWndProc=fnWndProc_OnVScroll(wea)
      Exit Function
    Case %WM_PAINT
      wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
      fnWndProc=fnWndProc_OnPaint(wea)
      Exit Function
    Case %WM_CLOSE
      wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
      fnWndProc=fnWndProc_OnClose(wea)
      Exit Function
  End Select

  fnWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function


Function WinMain(ByVal hIns As Long,ByVal hPrevIns As Long,ByVal lpCmdLn As Asciiz Ptr,ByVal iShow As Long) As Long
  Local hMainWnd As Dword,dwStyle As Dword
  Local winclass As WndClassEx
  Local szAppName As Asciiz*32
  Local Msg As tagMsg
  '
  szAppName="Scrolling"
  winclass.cbSize=SizeOf(winclass)                       :winclass.style=%CS_HREDRAW Or %CS_VREDRAW
  winclass.lpfnWndProc=CodePtr(fnWndProc)                :winclass.cbClsExtra=0
  winclass.cbWndExtra=0                                  :winclass.hInstance=hIns
  winclass.hIcon=LoadIcon(%NULL,ByVal %IDI_APPLICATION)  :winclass.hCursor=LoadCursor(%NULL,ByVal %IDC_ARROW)
  winclass.hbrBackground=GetStockObject(%WHITE_BRUSH)    :winclass.lpszMenuName=%NULL
  winclass.lpszClassName=VarPtr(szAppName)               :winclass.hIconSm=0
  Call RegisterClassEx(winclass)
  dwStyle=%WS_MINIMIZEBOX Or %WS_VISIBLE Or %WS_VSCROLL Or %WS_SYSMENU
  hMainWnd=CreateWindowEx(0,szAppName,szAppName,dwStyle,200,100,300,225,%HWND_DESKTOP,0,hIns,ByVal 0)
  ShowWindow hMainWnd,iShow
  UpdateWindow hMainWnd
  While GetMessage(Msg,%NULL,0,0)
    TranslateMessage Msg
    DispatchMessage Msg
  Wend

  Function=msg.wParam
End Function
